package middleware

import (
	"bytes"
	"git.sxidc.com/service-supports/fserr"
	"git.sxidc.com/service-supports/fslog"
	"io"
	"lcp/api/binding/http_binding/binding_context"
	"lcp/api/binding/http_binding/response"
	"lcp/errcode"
	"net/http"
)

func ReadRequestBodyData() Func {
	return func(c *binding_context.Context) {
		respFunc := response.SendMsgResponse

		contentType := c.Request.Header.Get("Content-Type")
		if c.Request.Body != nil && contentType == "application/json" &&
			(c.Request.Method == http.MethodPost || c.Request.Method == http.MethodPut) {
			bodyData, err := io.ReadAll(c.Request.Body)
			if err != nil {
				err = fserr.WithCode(err, errcode.ErrCommonGolangCall)
				fslog.Error(err)
				respFunc(c, http.StatusBadRequest, nil, err)
				c.Abort()
				return
			}

			fslog.Info(c.Request.RequestURI + " Request Body\n" + string(bodyData))

			_ = c.Request.Body.Close()
			c.Request.Body = nil
			c.Request.Body = io.NopCloser(bytes.NewReader(bodyData))
		}

		c.Next()
	}
}
